<?php
/**
* Joomla Community Builder User Plugin: plug_cbhelloworld
* @version $Id$
* @package plug_simplesort
* @author Mikko
* @copyright (C) www.mikkosoft.fi
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL

*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


$_PLUGINS->registerFunction( 'onStartUsersList','doFilter','filterColumns');
$_PLUGINS->registerFunction( 'onBeforeDisplayUsersList','addFilterToCols','filterColumns'); 

class filterColumns extends cbPluginHandler{
	

	function doFilter($listid, $row, $search, $limitstart, $limit, $ui){
		global $mainframe, $_CB_database,$mosConfig_debug;
		
		$filtercol=-1;
		$filtervalue=null;
		for($i=1;$i<=4;++$i){
			$filtervalue=mosGetParam($_POST,"filter".$i,null);
			
			if($filtervalue!=null){
				if($mosConfig_debug)
					echo "<p>Found filter data in POST</p>";
					
				$filtercol=$i;
				break;
			}
		}			
			
		if($filtercol!=-1&&$filtervalue!=null){
			
			if (!isset( $_SESSION['session_userstate'] )){
				$_SESSION['session_userstate']=array();
			}	

			$mainframe->setUserState("filter$listid-$filtercol",$filtervalue);
		}
		
		$filters=$this->getFilterArray($listid,$row,true);
		
		if(!empty($filters)){
			if($mosConfig_debug)
					echo "<p>Found filter data in session</p>";

			$_CB_database->setQuery("SELECT name,fieldid FROM #__comprofiler_fields WHERE fieldid in (".implode(",",array_keys($filters)).")");
			$fields=	$_CB_database->loadObjectList();

			$filterSQL = array();
			
			foreach($fields as $field){
				$filterSQL[]=$field->name." LIKE '".$filters[$field->fieldid]."%'";
			}
			if($mosConfig_debug)
					echo "<p>Created filter ".implode(" AND ",$filterSQL)."</p>";
			$search="-\n-";
			
			return array(implode(" AND ",$filterSQL));
		}
	}
	function getFilterArray($listid,$row,$byfieldid=false){
		global $mainframe;
		$ret=array();
		for($col=1;$col<=4;++$col){
			$value=$mainframe->getUserState("filter$listid-$col");
			if($value!=null&&$value!=''){
				if($byfieldid){
					$temp="col".$col."fields";
					$temp=$row->$temp;
					$temp=explode(",",$temp);	
					$fieldid=$temp[0];
					$ret[$fieldid]=$value;
				}
				else 
					$ret[$col]=$value;								
			}
		}
		return $ret;
	}
	function addFilterToCols($row, $users, $columns, $allFields, $lists, $listid, $search, $option_itemid, $ui){
		global $mainframe, $mosConfig_live_site;
		$ue_base_url			= "index.php?option=com_comprofiler&amp;task=usersList&amp;listid=" . $listid . $option_itemid; // . $spoofAmp;	// Base URL string


		$filters=$this->getFilterArray($listid,$row);
		
		foreach($columns as $colid=>$column){
			$colid++;
			$value=null;
			
			if(array_key_exists($colid,$filters))
				$value=$filters[$colid];
			
			$column->title=getLangDefinition( $column->title)."<br><form action=\"$ue_base_url\" metdod=\"POST\">"
				."<select name=\"filter$colid\" onchange=\"this.form.submit();\">"
				."<option value=\"\"".($value!=null&&$value!=''?" selected":"").">-</option>".
				$this->getFilterOptions($value,$column)
				."</select></form>";				
		}
	}
	function getFilterOptions($filtervalue,$column){
		global $database;
		
		$database->setQuery("SELECT name FROM #__comprofiler_fields WHERE fieldid=".$column->fields[0]);
		$field=$database->loadResult();
		$database->setQuery("SELECT DISTINCT LEFT($field,2) FROM #__comprofiler c, #__users u WHERE c.id=u.id");
		$res=$database->loadResultArray();
		
		$ret="";
		foreach($res as $value){
			$ret.="<option value=\"$value\"".($value==$filtervalue?" selected":"").">$value</option>";
		}
		return $ret;
	}
}